PPATH  Prime Path
The ministers of the cabinet were quite upset by the
message from the Chief of Security stating that they
would all have to change the fourdigit room numbers
on their offices.
— It is a matter of security to change such things
every now and then, to keep the enemy in the dark.
— But look, I have chosen my number 1033 for good
reasons. I am the Prime minister, you know!
— I know, so therefore your new number 8179 is also
a prime. You will just have to paste four new
digits over the four old ones on your office door.
— No, it's not that simple. Suppose that I change the
first digit to an 8, then the number will read 8033
which is not a prime!
— I see, being the prime minister you cannot stand
having a nonprime number on your door even for a
few seconds.
— Correct! So I must invent a scheme for going from
1033 to 8179 by a path of prime numbers where
only one digit is changed from one prime to the
next prime.
Now, the minister of finance, who had been eavesdropping,
intervened.
— No unnecessary expenditure, please! I happen to
know that the price of a digit is one pound.
— Hmm, in that case I need a computer program to
minimize the cost. You don't know some very cheap
software gurus, do you?
— In fact, I do. You see, there is this programming
contest going on...
Help the prime minister to find the cheapest prime path between any two given fourdigit primes! The first digit must be nonzero, of course. Here is a solution in the case above.
1033 1733 3733 3739 3779 8779 8179The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input
One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are fourdigit primes (without leading zeros).
Output
One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Example
Input: 3 1033 8179 1373 8017 1033 1033 Output: 6 7 0
hide comments
shivan11:
20180726 18:36:20
Good bfs problem. Store the sieve of prime numbers beforehand so you dont have to calculate all the prime numbers for every test case. 

kkislay20:
20180630 08:26:10
OMG this problem...I don't know about you guys but this was a really nice problem. The bfs,graph,sieve and concept was really good. I was getting WA even though all my answers were correct but there was one testcase which was not giving correct ans...I dont know why, After hitting walls for few hours I replaced the memset with loop and got AC.If you want to know the test case..this was the one


dennislo:
20180629 03:27:40
Good problem 

nitish235:
20180616 11:34:41
took 2 hrs to think this as bfs then got AC 0.15 

aman9598:
20180608 21:09:37
wrong testcases


atharva_sarage:
20180607 12:53:48
AC in first shot


flyingduchman_:
20180512 19:57:17
BFS tag ... What is the graph ?


maruf_robin:
20180503 19:02:58
Excellent Question. Fun to solve. I faced problem to add the edges but got AC in one go after hours. 

thanos_tapras:
20180422 13:16:10
Really nice problem! Great problem for BFS with good balance between concept difficulty and implementation difficulty. 

addynation:
20180315 00:19:03
AC in one go! 
Added by:  overwise 
Date:  20071002 
Time limit:  0.845s 
Source limit:  50000B 
Memory limit:  1536MB 
Cluster:  Cube (Intel G860) 
Languages:  All except: ERL JSRHINO NODEJS PERL6 VB.NET 
Resource:  ACM ICPC NWERC 2006 